/*
Copyright (c) 2007 The Regents of the University of California.
All rights reserved.
 
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software and that appropriate acknowledgments are made
to the research of the COSI group.
 
IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
 
THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
*/

/**
 *
 *@author Alessandro Pinto, 
 *@author apinto@eecs.berkeley.edu,
 *@author EECS Grad Student,
 *@author 211 Cory Hall #1772,
 *@author Berkeley, CA, 94720-1772
 *@author (510)-6429670
 
 */

#ifndef COSISYSCUTIL_H_
#define COSISYSCUTIL_H_

stringstream _cosiptpname_ ;

vector< DestIp<FLITWIDTH>* > _CosiDestIpVector_ ;


#define COSI_SOURCE_TO_ROUTER_CONNECTION( s , d , inp , layer , length ) cout << "Connecting source " << s << " to router " << d << endl ; \
    _cosiptpname_ << "S" << #s << "_R" << #d << "_in" << #inp ; \
    PtP< FLITWIDTH > S##s##_R##d##_in##inp( _cosiptpname_.str( ).c_str( ) ,  TechParam , layer , length ) ; \
    sc_signal< sc_bv< FLITWIDTH > > S##s##_Data ;				\
    sc_signal< bool > S##s##_Valid ;					\
    sc_signal< bool > S##s##_Ack ;					\
    sc_signal< bool > S##s##_Full ;					\
    S##s.DataOut( S##s##_Data ) ;						\
    S##s.ValidOut( S##s##_Valid ) ;					\
    S##s.AckIn( S##s##_Ack ) ;						\
    S##s.FullIn( S##s##_Full ) ;						\
    S##s##_R##d##_in##inp.DataIn( S##s##_Data ) ;				\
    S##s##_R##d##_in##inp.ValidIn( S##s##_Valid ) ;				\
    S##s##_R##d##_in##inp.AckOut( S##s##_Ack ) ;				\
    S##s##_R##d##_in##inp.FullOut( S##s##_Full ) ;				\
    sc_signal< sc_bv< FLITWIDTH > > R##d##_in##inp##_Data ;			\
    sc_signal< bool > R##d##_in##inp##_Valid ;				\
    sc_signal< bool > R##d##_in##inp##_Ack ;				\
    sc_signal< bool > R##d##_in##inp##_Full ;				\
    R##d.DataIn[ inp ]( R##d##_in##inp##_Data ) ;				\
    R##d.ValidIn[ inp ]( R##d##_in##inp##_Valid ) ;				\
    R##d.AckOut[ inp ]( R##d##_in##inp##_Ack ) ;				\
    R##d.FullOut[ inp ]( R##d##_in##inp##_Full ) ;				\
    S##s##_R##d##_in##inp.DataOut( R##d##_in##inp##_Data ) ;			\
    S##s##_R##d##_in##inp.ValidOut( R##d##_in##inp##_Valid ) ;			\
    S##s##_R##d##_in##inp.AckIn( R##d##_in##inp##_Ack ) ;			\
    S##s##_R##d##_in##inp.FullIn( R##d##_in##inp##_Full ) ;			

#define COSI_ROUTER_TO_ROUTER_CONNECTION( s , outp , d , inp , layer , length ) cout << "Connecting router " << s << " to router " << d << endl ; \
    _cosiptpname_ << "R" << #s << "_out" << #outp << "_R" << #d << "_in" << #inp ; \
    PtP< FLITWIDTH > R##s##_out##outp##_R##d##_in##inp( _cosiptpname_.str().c_str( ) ,  TechParam , layer , length ) ; \
    sc_signal< sc_bv< FLITWIDTH > > R##s##_out##outp##_Data ;		\
    sc_signal< bool > R##s##_out##outp##_Valid ;			\
    sc_signal< bool > R##s##_out##outp##_Ack ;				\
    sc_signal< bool > R##s##_out##outp##_Full ;				\
    R##s.DataOut[ outp ]( R##s##_out##outp##_Data ) ;			\
    R##s.ValidOut[ outp ]( R##s##_out##outp##_Valid ) ;			\
    R##s.AckIn[ outp ]( R##s##_out##outp##_Ack ) ;			\
    R##s.FullIn[ outp ]( R##s##_out##outp##_Full ) ;			\
    R##s##_out##outp##_R##d##_in##inp.DataIn( R##s##_out##outp##_Data ) ; \
    R##s##_out##outp##_R##d##_in##inp.ValidIn( R##s##_out##outp##_Valid ) ; \
    R##s##_out##outp##_R##d##_in##inp.AckOut( R##s##_out##outp##_Ack ) ; \
    R##s##_out##outp##_R##d##_in##inp.FullOut( R##s##_out##outp##_Full ) ; \
    sc_signal< sc_bv< FLITWIDTH > > R##d##_in##inp##_Data ;		\
    sc_signal< bool > R##d##_in##inp##_Valid ;				\
    sc_signal< bool > R##d##_in##inp##_Ack ;				\
    sc_signal< bool > R##d##_in##inp##_Full ;				\
    R##d.DataIn[ inp ]( R##d##_in##inp##_Data ) ;			\
    R##d.ValidIn[ inp ]( R##d##_in##inp##_Valid ) ;			\
    R##d.AckOut[ inp ]( R##d##_in##inp##_Ack ) ;			\
    R##d.FullOut[ inp ]( R##d##_in##inp##_Full ) ;			\
    R##s##_out##outp##_R##d##_in##inp.DataOut( R##d##_in##inp##_Data ) ; \
    R##s##_out##outp##_R##d##_in##inp.ValidOut( R##d##_in##inp##_Valid ) ; \
    R##s##_out##outp##_R##d##_in##inp.AckIn( R##d##_in##inp##_Ack ) ;	\
    R##s##_out##outp##_R##d##_in##inp.FullIn( R##d##_in##inp##_Full ) ;	

#define COSI_ROUTER_TO_DEST_CONNECTION( s , outp , d  , layer , length ) cout << "Connecting router " << s << " to destination " << d << endl ; \
    _cosiptpname_ << "R" << #s <<  "_out" << #outp << "_D"  << #d; \
    PtP< FLITWIDTH > R##s##_out##outp##_D##d( _cosiptpname_.str().c_str( )  ,  TechParam , layer , length ) ; \
    sc_signal< sc_bv< FLITWIDTH > > R##s##_out##outp##_Data ;		\
    sc_signal< bool > R##s##_out##outp##_Valid ;				\
    sc_signal< bool > R##s##_out##outp##_Ack ;				\
    sc_signal< bool > R##s##_out##outp##_Full ;				\
    R##s.DataOut[ outp ]( R##s##_out##outp##_Data ) ;			\
    R##s.ValidOut[ outp ]( R##s##_out##outp##_Valid ) ;			\
    R##s.AckIn[ outp ]( R##s##_out##outp##_Ack ) ;			\
    R##s.FullIn[ outp ]( R##s##_out##outp##_Full ) ;			\
    R##s##_out##outp##_D##d.DataIn( R##s##_out##outp##_Data ) ;		\
    R##s##_out##outp##_D##d.ValidIn( R##s##_out##outp##_Valid ) ;	\
    R##s##_out##outp##_D##d.AckOut( R##s##_out##outp##_Ack ) ;		\
    R##s##_out##outp##_D##d.FullOut( R##s##_out##outp##_Full ) ;	\
    sc_signal< sc_bv< FLITWIDTH > > D##d##_Data ;			\
    sc_signal< bool > D##d##_Valid ;					\
    sc_signal< bool > D##d##_Ack ;					\
    sc_signal< bool > D##d##_Full ;					\
    D##d.DataIn( D##d##_Data ) ;					\
    D##d.ValidIn( D##d##_Valid ) ;					\
    D##d.AckOut( D##d##_Ack ) ;						\
    D##d.FullOut( D##d##_Full ) ;					\
    R##s##_out##outp##_D##d.DataOut( D##d##_Data ) ;			\
    R##s##_out##outp##_D##d.ValidOut( D##d##_Valid ) ;			\
    R##s##_out##outp##_D##d.AckIn( D##d##_Ack ) ;			\
    R##s##_out##outp##_D##d.FullIn( D##d##_Full ) ;		       


void _CosiAddDestIp_( DestIp<FLITWIDTH>* D ) {
  _CosiDestIpVector_.push_back( D ) ;
}

#endif
